package rover;
class Block extends Node {
  private ListOfNodes node_list = new ListOfNodes();

  public ListOfNodes getNodeList() {
    return node_list;
  }

  public Block() {
    subtype = Node.NodeSubtypeBlock;
  }

  public Block(
    Symbol xid,
    ListOfNodes xlist,
    ListOfConditions xstart,
    ListOfConditions xend,
    ContinueType xcont) {
    super(
      NodeSubtypeBlock,
      xid,
      comment_default,
      xstart,
      wait_for_conditions_default,
      maintain_conditions_default,
      xend,
      order_constraints_default,
      utility_default,
      tail_utility_default,
      probability_default,
      xcont,
      default_continue_on_failure_default,
      alternate_plans_default);
    node_list = xlist;
  }

  public Block(Symbol xid, ListOfNodes xlist) {
    super(
      NodeSubtypeBlock,
      xid,
      comment_default,
      start_conditions_default,
      wait_for_conditions_default,
      maintain_conditions_default,
      end_conditions_default,
      order_constraints_default,
      utility_default,
      tail_utility_default,
      probability_default,
      continue_on_failure_default,
      default_continue_on_failure_default,
      alternate_plans_default);
    node_list = xlist;
  }

  public Block(
    Symbol xid,
    ListOfNodes xlist,
    ListOfConditions xstart,
    ListOfConditions xend) {
    super(
      NodeSubtypeBlock,
      xid,
      comment_default,
      xstart,
      wait_for_conditions_default,
      maintain_conditions_default,
      xend,
      order_constraints_default,
      utility_default,
      tail_utility_default,
      probability_default,
      continue_on_failure_default,
      default_continue_on_failure_default,
      alternate_plans_default);
    node_list = xlist;
  }

  public Block(Symbol xid, ListOfNodes xlist, ContinueType xcont) {
    super(
      NodeSubtypeBlock,
      xid,
      comment_default,
      start_conditions_default,
      wait_for_conditions_default,
      maintain_conditions_default,
      end_conditions_default,
      order_constraints_default,
      utility_default,
      tail_utility_default,
      probability_default,
      xcont,
      default_continue_on_failure_default,
      alternate_plans_default);
    node_list = xlist;
  }

  public Block(
    Symbol xid,
    String xcomment,
    ListOfConditions xstart_conditions,
    ListOfConditions xwait_for_conditions,
    ListOfConditions xmaintain_conditions,
    ListOfConditions xend_conditions,
    ListOfNodeIDs xorder_constraints,
    double xutility,
    double xtail_utility,
    double xprobability,
    ContinueType xcontinue_on_failure,
    ContinueType xdefault_continue_on_failure,
    ListOfAlternatePlans xalternate_plans,
  // Block-specific parameters
  ListOfNodes xnode_list) {
    super(
      NodeSubtypeBlock,
      xid,
      xcomment,
      xstart_conditions,
      xwait_for_conditions,
      xmaintain_conditions,
      xend_conditions,
      xorder_constraints,
      xutility,
      xtail_utility,
      xprobability,
      xcontinue_on_failure,
      xdefault_continue_on_failure,
      xalternate_plans);

    node_list = xnode_list;
  }

}