package rover;
public class CommunicationChannelSingleVariable
  extends CommunicationChannel
{
  public static interface OverrideFnType
  {
    boolean override(Object newObject, Object oldObject);
  }

  private Object                commVariable;
  private boolean               emptyChannel;
  private boolean               freeDeletedVariables;
  private OverrideFnType        overrideFn;

  public CommunicationChannelSingleVariable(OverrideFnType xoverrideFN,
                                            boolean xfreeDeletedVariables)
  {
    this(xoverrideFN, xfreeDeletedVariables, "SingleVar");
  }

  public CommunicationChannelSingleVariable(OverrideFnType xoverrideFN,
                                     boolean xfreeDeletedVariables,
                                     String xchannelID)
  {
    super(xchannelID);
    this.overrideFn = xoverrideFN;
    this.freeDeletedVariables = xfreeDeletedVariables;
    this.emptyChannel = true;
    this.commVariable = null;
  }
  
  public Object AddToCommunicationChannel(Object toAdd)
  {
    if (emptyChannel) 
      commVariable = toAdd;
    else if (overrideFn.override(toAdd, commVariable)) {
        //LM if (freeDeletedVariables)
        //LM   delete commVariable;
        commVariable = toAdd;
    }
    else {
      if (freeDeletedVariables) {
          //LM if (freeDeletedVariables)
          //LM   delete toAdd;
	toAdd = null;
      }
    }
    emptyChannel = false;
    return commVariable;
  }

  public Object ReadCommunicationChannel()
  {
    if (emptyChannel)
    {
      return null;
    }
    else
    {
      emptyChannel = true;
      return commVariable;
    }
  }

  public Object PeekCommunicationChannel()
  {
    return emptyChannel ? null : commVariable;
  }

  public Object PeekCommunicationChannelReader()
  {
    return PeekCommunicationChannel();
  }

  public Object PeekCommunicationChannelWriter()
  {
    return PeekCommunicationChannel();
  }

  public void ClearCommunicationChannel()
  {
    emptyChannel = true;
    // this should be checking freeDeletedVariables, right?!?
  }

  public void ClearCommunicationChannelReader()
  {
    ClearCommunicationChannel();
  }

  public void ClearCommunicationChannelWriter()
  {
    ClearCommunicationChannel();
  }

  public boolean EmptyCommunicationChannel()
  {
    return emptyChannel;
  }
}
