package rover;
import java.util.*;

class ExecWakeupTime implements Comparable {
  TimePoint tp;
  Symbol id;
  boolean failOnWakeup;
  Executive exec;

  public ExecWakeupTime(TimePoint xtp, 
			Symbol xid,
			boolean xfailOnWakeup,
			Executive xexec) {
    tp = xtp;
    id = xid;
    failOnWakeup = xfailOnWakeup;
    exec = xexec;
  }

  public String toString() {
    return "ExecWakeTime( " + id + "," + tp + ")";
  }

  public boolean equal(Symbol xid) {
    return (((xid == null) && (id == null) ) || 
	    ((xid != null) && (id != null) && 
	     id.equal(xid)));
  }
  
  public TimePoint getTimePoint() { 
    return tp; 
  }
  public Symbol getID() { 
    return id; 
  }
  public boolean getFailOnWakeup() { 
    return failOnWakeup; 
  }
  public Executive getExecutive() { 
    return exec; 
  }

  public int compareTo(Object o)
  {
    return tp.compareTo(((ExecWakeupTime)o).tp);
  }
}
