package rover;
import java.util.List;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;

class ExpandableListOfExecWakeupTimes {
  private ArrayList queue = new ArrayList();

  public String toString() {
    return String.valueOf(queue);
  }

  public void sortedInsert(ExecWakeupTime e) {
    int index;

    index = Collections.binarySearch(queue, e);
    if (index < 0) {
      queue.add(-(index + 1), e);
    }

    // System.out.println("\n\n\nsortedInsert: " + queue + "\n\n\n");
  }

  public void deleteWakeup(Symbol id) {
    if (id == null)
      return;
    int numDeleted = 0;

    for (Iterator i = queue.iterator(); i.hasNext();) {
      ExecWakeupTime e;
      e = (ExecWakeupTime)i.next();
      if ((e.getID() != null) && e.getID().equals(id)) {
	i.remove();
	numDeleted++;
      }
    }
    //System.out.println("Number deleted: " + numDeleted);
  }

  public Iterator getIterator() {
    return queue.iterator();
  }

  public void pushEnd(ExecWakeupTime e) {
    queue.add(e);
  }

  public void deleteListElements() {
    queue.clear();
  }

  public boolean empty() {
    return queue.isEmpty();
  }

  public int length() {
    return queue.size();
  }

  public ExecWakeupTime head() {
    return (ExecWakeupTime)queue.get(0);
  }

  public ExecWakeupTime pop() {
    ExecWakeupTime rv;

    rv = (ExecWakeupTime)queue.get(0);
    queue.remove(0);

    return rv;
  }
}
