package rover;
public class Factory {

  /* ExecTimer */
  public static ExecTimer newExecTimer() {
    if (Main.JPF)
      return new AbstractExecTimer();
    return new ExecTimer();
  }
  public static ExecTimer newExecTimer(TimePoint zero_tp) {
    if (Main.JPF)
      return new AbstractExecTimer(zero_tp);
    return new ExecTimer(zero_tp);
  }

  /* Executive */
  public static Executive newExecutive() {
    if (Main.JPF)
      return new AbstractExecutive();
    return new Executive();
  }
  public static Executive newExecutive(
    CommandTable cmdtab,
    FunctionTable fntab,
    ExternalSystem externSys,
    ExecDisplay xdisplay,
    TelemetryInterface xtelemInterface) {
    if (Main.JPF)
      return new AbstractExecutive(
        cmdtab,
        fntab,
        externSys,
        xdisplay,
        xtelemInterface);
    else if (Main.RUNTIME)
      return new RuntimeExecutive(
        cmdtab,
        fntab,
        externSys,
        xdisplay,
        xtelemInterface);
    return new Executive(cmdtab, fntab, externSys, xdisplay, xtelemInterface);

  }

  /* TimePoint */
  public static TimePoint newTimePoint() {
    if (Main.JPF)
      return new AbstractTimePoint();
    return new TimePoint();
  }

  public static TimePoint newTimePoint(long secs, int msec) {
    if (Main.JPF)
      return new AbstractTimePoint(secs, msec);
    return new TimePoint(secs, msec);
  }

}
