package rover;
class Symbol implements Comparable {
  String printname;
  static Symbol NullSymbol = null;

  public String toString() {
    return printname;
  }

  public Symbol() { 
    printname = new String(); 
  }

  public Symbol(String pname) { 
    if (pname != null)
      printname = new String(pname);
    else
      printname = new String();
  }
  
  public Symbol(Symbol sym) { 
    if (sym.get_printname() != null)
      printname = new String(sym.get_printname());
    else
      printname = new String();
  }

  boolean equalnocase(Symbol s) { 
    if ((printname != null) && (s.printname != null))
      return (printname.equalsIgnoreCase(s.printname));
    else
      return (printname == s.printname); // both null
  }

  boolean equal(Symbol s) { 
    return (equalnocase(s));
  }

  public boolean equals(Object o)
  {
    return o instanceof Symbol && equal((Symbol)o);
  }

  String get_printname() { 
    return printname; 
  }

  public int compareTo(Object obj)
  {
    Symbol o = (Symbol)obj;
    if ((printname != null) && (o.printname != null)) {
      return printname.compareTo(o.printname);
    }
    else if (printname == null) {
      return -1;
    }
    else {
      return 1;
    }
  }
}
