package rover;
class Task extends Node {
	
  long duration = 0;       //for test purposes, how long in millis to execute
  boolean succeed = true;  //for test purposes, whether the task succeeds or not	

  int command_id = -1;
  Symbol action = new Symbol();
  ListOfDBParameters parameters = new ListOfDBParameters();
  ListOfDBParameters interrupt_parameters = new ListOfDBParameters();
  Symbol interrupt = new Symbol();
  

  public Task() {
    subtype = Node.NodeSubtypeTask;
  }
  
 //AG added constructor 

  public Task(
    Symbol xid,
    ListOfConditions xstartConditions,
    ListOfConditions xendConditions,
    ContinueType xcontinueOnFailure,
    Symbol xActionName,
    boolean  xsucceed,
    long xduration) {

    super(NodeSubtypeTask, 
    xid, 
    comment_default, 
    xstartConditions, 
    wait_for_conditions_default, 
    maintain_conditions_default,
    xendConditions,
    order_constraints_default,
    utility_default,
    tail_utility_default,
    probability_default,
    xcontinueOnFailure,
    default_continue_on_failure_default,
    alternate_plans_default);

    action = xActionName;
    succeed = xsucceed;
    duration = xduration;
  }

  public Task(
    Symbol xid,
    Symbol xaction,
    ListOfConditions xstart,
    ListOfConditions xend,
    ListOfConditions xwait) {
    super(
      NodeSubtypeTask,
      xid,
      comment_default,
      xstart,
      xwait,
      maintain_conditions_default,
      xend,
      order_constraints_default,
      utility_default,
      tail_utility_default,
      probability_default,
      continue_on_failure_default,
      default_continue_on_failure_default,
      alternate_plans_default);

    action = xaction;
  }

  public Task(
    Symbol xid,
    String xcomment,
    ListOfConditions xstart_conditions,
    ListOfConditions xwait_for_conditions,
    ListOfConditions xmaintain_conditions,
    ListOfConditions xend_conditions,
    ListOfNodeIDs xorder_constraints,
    double xutility,
    double xtail_utility,
    double xprobability,
    ContinueType xcontinue_on_failure,
    ContinueType xdefault_continue_on_failure,
    ListOfAlternatePlans xalternate_plans,
  // Task-specific parameters
  Symbol xaction,
    ListOfDBParameters xparameters,
    int xpriority,
    ListOfConditions xeffects,
  /*WV SetOfNodes xdecomposition,*/
  /*ListOfExpectations xexpectations,*/ Symbol xinterrupt,
    ListOfDBParameters xinterrupt_parameters,
    boolean xfail_on_interrupt) {
    super(
      NodeSubtypeTask,
      xid,
      xcomment,
      xstart_conditions,
      xwait_for_conditions,
      xmaintain_conditions,
      xend_conditions,
      xorder_constraints,
      xutility,
      xtail_utility,
      xprobability,
      xcontinue_on_failure,
      xdefault_continue_on_failure,
      xalternate_plans);

    action = xaction;
    //WV     parameters = xparameters;
    //WV    priority = xpriority;
    //WV effects = xeffects; 
    //WV decomposition = xdecomposition;
    //WV expectations = xexpectations; 
    //WV interrupt = xinterrupt;
    //WV interrupt_parameters = xinterrupt_parameters;
    //WV fail_on_interrupt = xfail_on_interrupt;
    //WV command_id = -1;
    //  initExtra();
  }

  public int get_command_id() {
    return command_id;
  }

  public void set_command_id(int cmdID) {
    command_id = cmdID;
  }

  public Symbol get_action() {
    return action;
  }

  public ListOfDBParameters get_parameters() {
    return parameters;
  }

  public ListOfDBParameters get_interrupt_parameters() {
    return interrupt_parameters;
  }

  Symbol get_interrupt() {
    return interrupt;
  }
}