package rover;

//import com.TimeRover.DBRover.httpconnect.*;

abstract class TestCase{
  private long startTime = System.currentTimeMillis();  
  private String name;
  private int state;
  protected int millis;
  //protected static HttpConnect httpConnect = new HttpConnect();

  abstract public Node plan();

  public void resetStartTime(){
  	startTime = System.currentTimeMillis();
  }
 
  public void check(String name,int state){
  	this.name = name;
  	this.state = state;
    this.millis = (int)(System.currentTimeMillis() - startTime);
    print();
    //if(Main.testSuite.useDBRover)monitor();
  }
 
  protected Node parsePlan(String p) {
    PlanParser pp = new PlanParser(p);
    try{
      return pp.parsePlan();
    }
    catch (ParseException e){
      System.out.println("*** Syntax error in plan");
      e.printStackTrace();
    }
    return null;
  }

  private void print(){
    String state_txt = (state == 0?"start":
                         (state == 1 ? "success" : "failure"));
    System.out.println("[observe] " + state_txt + " " + name + " at time " + millis);
  }

  protected boolean start(String name){
  	return this.name.equals(name) && state == 0;
  }

  protected boolean end(String name){
    return this.name.equals(name) && state != 0;	
  }
  
  protected boolean success(String name){
  	return this.name.equals(name) && state == 1;
  }
  
  protected boolean fail(String name){
  	return this.name.equals(name) && state == -1;
  }
  
  protected boolean terminating(){
  	return state != 0;
  }
  
  protected boolean terminated(){
  	return false;
  }
  
  protected boolean within(int lo_s,int lo_m,int up_s,int up_m){
  	return (lo_s *1000 + lo_m) <= millis &&
  	       millis <= (up_s * 1000 + up_m);
  }

  protected boolean within(int lo_s,int up_s){
  	return within(lo_s,0,up_s,0);
  }

  //abstract protected void monitor();
}
