package rover;

import java.util.*;

class TestSuite{
  private Vector testcases = new Vector();
  private int indexOfCurrentTestCase = -1;
  private TestCase currentTestCase = null;
  public boolean useDBRover = true;

  
  public void check(String name,int state){
  	 currentTestCase.check(name, state);
  }
  
  public void reset(){
  	indexOfCurrentTestCase = -1;
  	currentTestCase = null;
  }
  
  public boolean hasNext(){
  	return (indexOfCurrentTestCase  + 1 < testcases.size());
  }
  
  public Node next(){
  	if (!hasNext()) return null;
  	else{
  	  indexOfCurrentTestCase++;
  	  currentTestCase = (TestCase) testcases.get(indexOfCurrentTestCase);
      currentTestCase.resetStartTime();
  	  return currentTestCase.plan();
  	}
  }
  		
  	
  
  public void add(TestCase tc){
  	testcases.add(tc);
  }

  public Iterator getTestCases(){
    return testcases.iterator();
  }
  
  
	/**
	 * Gets the useDBRover
	 * @return Returns a boolean
	 */
	public boolean getUseDBRover() {
		return useDBRover;
	}
  /**
   * Sets the useDBRover
   * @param useDBRover The useDBRover to set
   */
  public void setUseDBRover(boolean useDBRover) {
    this.useDBRover = useDBRover;
  }

}
