package rover;
class TimeCondition extends Condition {

  TimeInterval interval;

  public TimeCondition() {
    TimeDate start = null; 
    TimeDate end = null; 
    interval = new TimeInterval(start, end);
    subtype = TimeConditionSubtype;
  }

  public TimeCondition(TimeDate start, TimeDate end) {
    interval = new TimeInterval(start, end);
    subtype = TimeConditionSubtype;
  }

  boolean equal(TimeCondition other) {
    return (interval.equal(other.getInterval()));
  }

  boolean equal(Condition other) { 
    return false; 
  }

  // TimeConditions never have variables.
  boolean hasVariables() { 
    return false; 
  }

  TimeInterval getInterval() {
    return interval;
  }

  TimeDate getStartTime() { 
    try{return ((TimeDate) interval.getStartTime());} catch (Exception e) {
      interval.getEndTime().e.printStackTrace();
      e.printStackTrace();
    };
    return null;
  }
  
  TimeDate getEndTime() { 
    try{return ((TimeDate) interval.getEndTime());} catch (Exception e) {
      interval.getEndTime().e.printStackTrace();
      e.printStackTrace();
    };
    return null;
  }

  void setStartTime(TimeDate lbound) {
    interval.setStartTime(lbound);
  }

  void setEndTime(TimeDate ubound) {
    interval.setEndTime(ubound);
  }

  TimePoint intervalSize() { 
    return (interval.intervalSize()); 
  }

  boolean satisfied(ListOfVariableBindings bindings, 
			 TimePoint referenceTime,
			 TimePoint currentTime) { 
    if (Main.print)
      System.out.println("TimeCondition::satisfied, time condition = "+this);
    TimeDate cond_stime = getStartTime();
    TimeDate cond_etime = getEndTime();
    // offsetStart and offsetEnd are used when the condition has
    // relative time points -- they are then deleted, since they
    // are created when the offset is added to the reference time.
    TimePoint offsetStart = null;
    TimePoint offsetEnd = null;
    // absStart and absEnd either point to offsetStart and offsetEnd
    // or cond_stime and cond_etime.  They do not get deleted.
    TimePoint absStart = cond_stime;
    TimePoint absEnd = cond_etime;

    // Now compare each of these against current bounds.
    if (cond_stime != null) {
      if (cond_stime.isrelative()) {
	if (Main.print)
	  System.out.println("TimeCondition::satisfied: Relative condition lower bound");
	offsetStart = referenceTime.plus(cond_stime);
	absStart = offsetStart;
      } else {
	if (Main.print)
	  System.out.println("TimeCondition::satisfied: Absolute condition lower bound");
	absStart = cond_stime;
      }
    }
    if (cond_etime != null) {
      if (cond_etime.isrelative()) {
	if (Main.print)
	  System.out.println("TimeCondition::satisfied:: Relative condition upper bound");
	offsetEnd = referenceTime.plus(cond_etime);
	absEnd = offsetEnd;
      } else {
	if (Main.print)
	  System.out.println("TimeCondition::satisfied:: Absolute condition upper bound");
	absEnd = cond_etime;
      }
    }
  
    if (Main.print)
      System.out.println("TimeCondition::satisfied -- Comparing current time ("
			 + currentTime + ") against interval [" + absStart + 
			 "," + absEnd);
    boolean result = true;
    if ((absStart != null) && currentTime.lt(absStart))
      result = false;
    else if ((absEnd != null) && currentTime.gt(absEnd))
      result = false;
    offsetStart = null;
    offsetEnd = null;
    //WV    if (offsetStart)
    //WV  delete offsetStart;
    //WV if (offsetEnd)
    //WV  delete offsetEnd;
    return result;
  }

}
