package rover;
import com.ibm.contest.utils.QuickRandom;

//import gov.nasa.jpf.jvm.Verify;

class UniversalPlanner {

	private static QuickRandom ctRandom = QuickRandom.newInstance((int) System.currentTimeMillis());

		/* generates plans from simplified grammar */
    /*
			UniversalNode -> UniversalTask | UniversalBlock
			UniversalTask -> id action start end wait
			UniversalBlock -> id ListOfNodes continue
		*/

		static int param = 0; /* create a plan with up to param nodes */

		public static Node UniversalPlan(int p) {
				param = p;
				//System.out.println("Universal plan "+param);
				return UniversalNode();
		}

		public static Node UniversalNode() {
				if (param == 0) return null;
				System.out.println("node "+param);

				// null plan:
        // if (//Verify.randomBool()) return null;
        
//ZL				if (Verify.randomBool()) 
				if (ctRandom.nextBoolean())
					return UniversalTask();
				else 
					return UniversalNode();
		}

		public static Node UniversalTask() {
        System.out.println("task "+param);
				Symbol id = new Symbol("task" + param);
				Symbol action = new Symbol("dummy" + param);
				param--;

				ListOfConditions start = null;
        ListOfConditions end = null;
        ListOfConditions wait = null;

				TimeCondition time;
				/* we don't care about actual values */

				if (ctRandom.nextBoolean()){
//ZL				if (Verify.randomBool()) {
						start = new ListOfConditions();
						time = new TimeCondition(new TimeDate(1,0), new TimeDate(1,0));
						start.pushEnd(time);
				}

				if (ctRandom.nextBoolean()){
//ZL				if (Verify.randomBool()) {
						end = new ListOfConditions();
						time = new TimeCondition(new TimeDate(1,0), new TimeDate(1,0));
						end.pushEnd(time);

				}

				if (ctRandom.nextBoolean()){
//ZL				if (Verify.randomBool()) {
						wait = new ListOfConditions();
						time = new TimeCondition(new TimeDate(1,0), new TimeDate(1,0));
						wait.pushEnd(time);
				}

				Task t = new Task(id, action, start, end, wait);
				t.compileStartConditions();
				t.compileEndConditions();
				return t;
		}

		public static Node UniversalBlock() {
				//System.out.println("block "+param);
				Symbol id = new Symbol("block" + param);
				param--;

				ListOfNodes l; 
				l = new ListOfNodes(); /* do we also want l to be null ? */
				for(Node n=UniversalNode();n!=null 
								&& ctRandom.nextBoolean(); /* not needed if we model null plan */
						    n=UniversalNode())
						l.pushEnd(n);
				Block b = new Block(id,l,new ContinueType(ctRandom.nextBoolean()));
//ZL				Block b = new Block(id,l,new ContinueType(Verify.randomBool()));
				return b;
		}
}
